/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2004 createagaga
 * Copyright (C) 2002-2009 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef AG_EMOTICON_SETUP_H
#define AG_EMOTICON_SETUP_H

#pragma once

#include "../client/Util.h"

class CAGEmoticon {
public:
	typedef CAGEmoticon* Ptr;
	typedef vector<Ptr> List;
	typedef List::iterator Iter;

	CAGEmoticon();
	~CAGEmoticon();
	
	bool Create(tstring& strEmoticonText, tstring& strEmoticonBmpPath);

	const tstring& GetEmoticonText();
	HBITMAP GetEmoticonBmp(const COLORREF &clrBkColor);
private:
    bool bWithAlpha;
	HBITMAP m_EmoticonBmp;
    LONG lWidth; 
    LONG lHeight; 
	tstring m_EmoticonText;
};

// CAGEmoticonSetup
class CAGEmoticonSetup {
public:
	CAGEmoticonSetup();
	~CAGEmoticonSetup();

	bool Create(const string& emoticonfile);

    // Variables
	GETSET(bool, UseEmoticons, UseEmoticons);

    // Emoticon list
	CAGEmoticon::List EmoticonsList;
};

#endif // AG_EMOTICON_SETUP_H
