/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2003 Trpaslik
 * Copyright (C) 2003-2004 createagaga
 * Copyright (C) 2002-2009 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */
			
#ifndef CHAT_CTRL_H
#define CHAT_CTRL_H

#pragma once

#include "WinUtil.h"
#include "../client/Client.h"

#ifndef _RICHEDIT_VER
#define _RICHEDIT_VER 0x0300
#endif

class ChatCtrl {
public:
	ChatCtrl();
	~ChatCtrl();

	void OnRButtonDown(POINT pt);

	bool HitNick(POINT p, tstring &sNick, int &iBegin, int &iEnd);
	bool HitIP(POINT p, tstring &sIP, int &iBegin, int &iEnd);
	bool HitURL();
	bool GetAutoScroll();

	tstring LineFromPos(POINT p);

	void AdjustTextSize();
	void AppendText(const Identity& i, const tstring& sMyNick, const tstring& sTime, const tstring& sIP, const tstring& sMsg, CHARFORMAT2& cf, bool bUseEmo = true);
	void AppendText(const tstring&  sMyNick, const tstring&  sTime, const tstring& sMsg, CHARFORMAT2& cf, const tstring& sAuthor = Util::emptyStringT, int iAuthorLen = 0, bool isMe = false, bool bUseEmo = true);
	long AppendTextOnly(const tstring& sMyNick, const TCHAR *sText, TCHAR *sMsgLower, const size_t iTextLen, CHARFORMAT2& cf, bool bMyMess, bool bUrlOnEnd = false);
	void AppendStatusText(const tstring& sTime, tstring sMsg, CHARFORMAT2& cf);
	void EndRedrawAppendTextOnly();

	void GoToEnd();
	void ClearChat();
	void SetAutoScroll(bool boAutoScroll);
	void SetClient(Client * pClient);
	void SetTextStyleMyNick(CHARFORMAT2 ts) { WinUtil::m_TextStyleMyNick = ts; };

    int CharFromPos(const POINT &pt);
	void GetLine(const int &iIndex, LPTSTR lpszBuffer, const int &iMaxLength);
    void GetSel(LONG &lStartChar, LONG &lEndChar);
    int GetTextRange(const LONG &lStartChar, const LONG &lEndChar, const LPTSTR &lpstrText);
    void SetSel(const LONG &lStartChar, const LONG &lEndChar);
    void SetSelAll();

	static tstring sSelectedUser;
	static tstring sSelectedLine;
	static tstring sSelectedIP;

    HWND m_hWnd;
private:
    bool m_boAutoScroll;
    Client* client;

	IRichEditOle* GetOleInterface();
	int GetTextLengthEx(const DWORD &dwFlags);
	void InsertBitmap(HBITMAP hBitmap);
};


#endif // CHAT_CTRL_H
