/*
 * Copyright (C) 2001-2007 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef MDI_CHILD_WINDOW_H
#define MDI_CHILD_WINDOW_H

class MDITabChildWindow {
public:
	MDITabChildWindow();
	~MDITabChildWindow() { }

    bool MDIWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT& lResult);

	void onForwardMsg(LPARAM lParam);
	bool onSysCommand(WPARAM wParam);
	void onMDIActivate(LPARAM lParam);
	void onDestroy();
	void onSetText(LPARAM lParam);
	LRESULT onMouseActivate(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    void CreateEx(void * pOwner, ATOM aAtom, UINT uiResourceID, LPRECT rect = NULL, LPCTSTR lpcstrWindowName = NULL);
	void setDirty();
	void setTabColor(COLORREF color);
	void setIconState();
	void unsetIconState();
	void UpdateBarsPosition(RECT& rect, bool bResizeBars = true);
	bool UpdateClientEdge(LPRECT lpRect = NULL);
	void onWindowPosChanged(LPARAM lParam);

	HWND m_hWnd, m_hWndStatusBar;

	bool created;
private:
    HACCEL m_hAccel;
};

#endif // MDI_CHILD_WINDOW_H

/*
 * Some parts Copyright (C) 2002-2009 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
