/* 
 * Copyright (C) 2003 Twink,  spm7@waikato.ac.nz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef PREVIEWPAGE_H
#define PREVIEWPAGE_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PropPage.h"
#include "ExListViewCtrl.h"
#include "resource.h"

class PreviewApplication;

class PreviewPage : public PropPage {
public:
	PreviewPage(SettingsManager *s);
	~PreviewPage();

	void onInitDialog();
	void onAddMenu();
	void onChangeMenu();
	void onRemoveMenu();
	void onItemchanged(LPNMHDR pnmh);
	bool onKeyDown(LPNMHDR pnmh);

	// Common PropPage interface
	PROPSHEETPAGE *getPSP() { return (PROPSHEETPAGE *)*this; }
	void write() { }
private:
	ExListViewCtrl ctrlCommands;
	static TextItem texts[];
	TCHAR* title;
	void addEntry(PreviewApplication* pa, int pos);

    static BOOL CALLBACK PreviewPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};

#endif

/*
 * Some parts Copyright (C) 2002-2009 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
