/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2009 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */
 
//----------------------------------------------------------------------------------------------------------------------------------------------------
#ifndef CSPLITERWINDOW_UTIL_H
#define CSPLITERWINDOW_UTIL_H
//----------------------------------------------------------------------------------------------------------------------------------------------------
#pragma once
//----------------------------------------------------------------------------------------------------------------------------------------------------
#define SPLIT_PANE_LEFT_OR_TOP          0
#define SPLIT_PANE_RIGHT_OR_BOTTOM      1
#define SPLIT_PANE_NONE                 -1
//----------------------------------------------------------------------------------------------------------------------------------------------------
#define SPLIT_NONINTERACTIVE    0x1
#define SPLIT_FIX_PAINT         0x2
//----------------------------------------------------------------------------------------------------------------------------------------------------
static const UINT WM_UPDATE_FILTER_LAYOUT = WM_APP + 706;
//----------------------------------------------------------------------------------------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CSplitter

class CSplitter {
public:
    CSplitter();
    ~CSplitter() { }

    bool CSplitterProc(UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT& lResult);

    void SetSplitterRect(const LPRECT &lpRect);
    bool SetSplitterPos(int iPos, const bool &bUpdate = true);
    void SetSinglePaneMode(const int8_t &i8Pane);
    void SetSplitterExtendedStyle(const uint8_t &ui8NewExtendedStyle);
    void SetSplitterPanes(const HWND &hWndLeftTop, const HWND &hWndRightBottom);
    bool GetSplitterPaneRect(const uint8_t &i8Pane, LPRECT lpRect);
    void SetSplitterHorCursor();

    int8_t i8SinglePane;
    int iProportionalPos;
    HWND m_hSplitWnd;
private:
	void OnPaint();
	bool OnMouseMove(WPARAM wParam, LPARAM lParam);
	void OnLButtonDown(LPARAM lParam);
	void OnLButtonUp();
	void OnSetFocus();

	void OnMouseActivate(LRESULT lResult);
	void DrawSplitter(const HDC &dc);
	void UpdateSplitterLayout();
	bool GetSplitterBarRect(RECT &Rect);
	bool IsOverSplitterBar(const int &x, const int &y);

    bool bUpdateProportionalPos, bVertical;
    HWND hWndPanes[2];
    int iSplitterPos, iDragOffset;
    int8_t i8DefActivePane;
    RECT rcSplitter;
    uint8_t ui8ExtendedStyle;
    HCURSOR hCursor;
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CSplitterWindow

class CSplitterWindow : public CSplitter {
public:
    CSplitterWindow();
    ~CSplitterWindow() { }

    static LRESULT CALLBACK SplitterWindowWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
    LRESULT SplitterWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	void Create(HWND hWndParent);

	HWND m_hWnd;
private:
    void OnSize(WPARAM wParam);
};
//----------------------------------------------------------------------------------------------------------------------------------------------------

#endif
