/*
 * CzDC - client for Direct Connect peer to peer network.

 * Copyright (C) 2002-2009 Petr Kozelka, PPK at CzDC dot org

 * CzDC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3
 * as published by the Free Software Foundation.

 * CzDC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with CzDC. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef THEMESPAGE_H
#define THEMESPAGE_H

#include "PropPage.h"

class ThemesPage : public PropPage {
public:
	ThemesPage(SettingsManager *s);
	~ThemesPage();

	void onInitDialog();
	void onBrowse();
	void onRefresh();
	bool onChangeColour(HWND hWndCtl);
	
	// Common PropPage interface
	PROPSHEETPAGE *getPSP() { return (PROPSHEETPAGE *)*this; }
	void write();
private:
    void refreshPreview();
	int normalColour;
	int favoriteColour;
	int reservedSlotColour;
	int ignoredColour;
	int fastColour;
	int serverColour;
	int activeColour;
	int pasiveColour;
	int opColour; 

    void AppendTxt(const TCHAR * sTxt);

	static Item items[];
	static TextItem texts[];
	TCHAR* title;

    static BOOL CALLBACK ThemesPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};

#endif //THEMESPAGE_H
